﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using System.Text;

namespace ThinService
{
    public partial class ThinService : ServiceBase
    {
        /// <summary>
        /// Thinプロセス格納用リスト
        /// </summary>
        private Process thinProcess = null;

        /// <summary>
        /// コンストラクタ
        /// </summary>
        public ThinService()
        {
            InitializeComponent();
        }

        /// <summary>
        /// サービス開始
        /// </summary>
        /// <param name="args">引数</param>
        protected override void OnStart(string[] args)
        {
            string rubyPath = Environment.GetCommandLineArgs()[1];
            string thinPath = Environment.GetCommandLineArgs()[2];
            string redminePath = Environment.GetCommandLineArgs()[3];
            string startPort = Environment.GetCommandLineArgs()[4];

            this.thinProcess = Process.Start(rubyPath, "\"" + thinPath + "\" \"-e\" \"production\" \"-p\" " + startPort + " \"-c\" \"" + redminePath + "\" \"start\"");
        }

        /// <summary>
        /// サービス停止
        /// </summary>
        protected override void OnStop()
        {
            this.thinProcess.Kill();
        }
    }
}
